SystemOrganization addCategory: #'Orca-Tools'!
SystemOrganization addCategory: #'Orca-Tools-Tests'!

Model subclass: #OrcaControlPanel
	instanceVariableNames: 'compilingNotification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools'!

OrcaControlPanel class
	instanceVariableNames: 'instance'!

!OrcaControlPanel commentStamp: 'sw 4/14/2011 10:38' prior: 0!
I am a configuration panel for the Orca Webframework.

I can set swazooDebug ->  Smalltalk at: #OrcaDebugSwazooInternalErrors

Default: the print messages are disabled.
in Smalltalk -> see updatesKey.

OrcaTranslatedClass disablePrintUpdates 
OrcaTranslatedMethod disablePrintUpdates 


entweder cacheCodeFor:  producedBy: 
	speicher state
	set on
	work
	reset state
	
oder in codeForClasses: 

precompile postcompile block -> setzt flag auf controlpanel (und zeigt notification an)!

OrcaControlPanel class
	instanceVariableNames: 'instance'!

!OrcaControlPanel class methodsFor: 'accessing' stamp: 'sw 4/14/2011 11:43'!
instance
	instance isNil ifTrue: [
		self instance: (ToolBuilder build: self)].
	^ instance! !

!OrcaControlPanel class methodsFor: 'accessing' stamp: 'sw 4/14/2011 11:39'!
instance: anObject
	instance := anObject! !

!OrcaControlPanel class methodsFor: 'open' stamp: 'sw 4/14/2011 11:44'!
open

	^ self instance openInWorld ! !

!OrcaControlPanel class methodsFor: 'accessing' stamp: 'sw 4/14/2011 11:40'!
reset
	self instance: nil! !

!OrcaControlPanel class methodsFor: 'configuration' stamp: 'sw 4/14/2011 10:25'!
sizeOfCheckBoxes

	^ self sizeOfCheckBoxesWidth @ self sizeOfCheckBoxesHeight ! !

!OrcaControlPanel class methodsFor: 'configuration' stamp: 'sw 4/14/2011 10:24'!
sizeOfCheckBoxesHeight

	^ 0.08! !

!OrcaControlPanel class methodsFor: 'configuration' stamp: 'sw 4/14/2011 10:24'!
sizeOfCheckBoxesWidth

	^ 0.8! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 14:12'!
buildWith: builder

	| windowSpec buttonSpec optionSpec checkboxPanelSpec result fileChoserPanelSpec fileInput |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec extent: 500@400;
		model: self;
		label: self class name asString;
		children: OrderedCollection new.
	
	checkboxPanelSpec := builder pluggablePanelSpec new.
	checkboxPanelSpec
		model: self;
		layout:#vertical;
		frame: (0.1 @ 0.09 extent: self class sizeOfCheckBoxesWidth @ 0.3 );
		children: OrderedCollection new.
	windowSpec children add: checkboxPanelSpec.	
	
	optionSpec := builder pluggableCheckBoxSpec new.
	optionSpec
		model: self;
		label: #labelDebugSwazooMessages;
		state: #debugSwazooMessages;
		action: #changeDebugSwazooMessages.
	checkboxPanelSpec children add: optionSpec.
	
	optionSpec := builder pluggableCheckBoxSpec new.
	optionSpec
		model: self;
		label: #labelShowCompilingNotification;
		state: #compilingNotificationIsVisible;
		action: #changeShowCompilingNotification.
	checkboxPanelSpec children add: optionSpec.
	
	fileChoserPanelSpec := builder pluggablePanelSpec new.
	fileChoserPanelSpec
		model: self;
		layout:#horizontal;
		frame: (0.1 @ 0.5 extent: self class sizeOfCheckBoxesWidth @ 0.1 );
		children: OrderedCollection new.
	windowSpec children add: fileChoserPanelSpec.	
	
	fileInput := builder pluggableInputFieldSpec new.
	fileInput model: self;
			 getText: #currentRootDirectory;
			name: #rootdirectory;
			
			 setText: #setCurrentRootDir:notifying: ;
			 selection: #selection.
	fileChoserPanelSpec children add: fileInput.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'chose';
		color: #runButtonColor;
		action: #choseRootdirectory.
	fileChoserPanelSpec children add: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'clear cache';
		color: #runButtonColor;
		action: #clearCache;
		frame: (0.1 @ 0.9 extent: 0.25 @ 0.1).
	windowSpec children add: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'forced restart';
		color: #runButtonColor;
		action: #forcedRestart;
		frame: (0.4 @ 0.9 extent: 0.25 @ 0.1).
	windowSpec children add: buttonSpec.

	result := builder build: windowSpec.

	result addMorph: self compilingNotification.
	self setMorphColorsOf: result submorphs.

	
	^ result.
	
	"OrcaControlPanel  open."! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/12/2011 15:42'!
changeDebugSwazooMessages

	Smalltalk at: #OrcaDebugSwazooInternalErrors put:
		((Smalltalk at: #OrcaDebugSwazooInternalErrors ifAbsent: [false ]) not)! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/14/2011 12:52'!
changeShowCompilingNotification

	self compilingNotificationIsVisible 
		ifTrue:   [ self disableCompilingNotfication ]
		ifFalse:  [ self enableCompilingNotfication ].
	! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 11:30'!
checkboxColor

	^ Color white! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 14:14'!
choseRootdirectory
	
	| chooser directory |
	chooser := FileChooser new.
	directory := chooser
		initializeAsSystemWindow;
		open;
		directory.
	OrcaFileRequestHandler rootDirectory: directory pathName.
	self changed: #currentRootDirectory.! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/12/2011 16:21'!
clearCache

	OrcaCodeFactory clearCache.
	OrcaPrettyCodeFactory clearCache.! !

!OrcaControlPanel methodsFor: 'accessing' stamp: 'sw 4/14/2011 12:53'!
compilingNotification
	^ compilingNotification! !

!OrcaControlPanel methodsFor: 'accessing' stamp: 'sw 4/14/2011 12:53'!
compilingNotification: anObject
	compilingNotification := anObject! !

!OrcaControlPanel methodsFor: 'testing' stamp: 'sw 4/14/2011 12:52'!
compilingNotificationIsVisible

	^ OrcaAbstractCodeFactory instance precompileBlock isNil not! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 14:18'!
currentRootDirectory

	| rootdirectory |
	
	rootdirectory := Smalltalk at: #OrcaFileRootDirectory  ifAbsent: [  ^ ''].
	^ rootdirectory pathName! !

!OrcaControlPanel methodsFor: 'testing' stamp: 'sw 4/12/2011 15:42'!
debugSwazooMessages

	^ Smalltalk at: #OrcaDebugSwazooInternalErrors ifAbsent: [false ]! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/14/2011 13:18'!
disableCompilingNotfication 

	! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/14/2011 13:18'!
enableCompilingNotfication

	! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/12/2011 16:37'!
forcedRestart

	OrcaDispatcher forcedRestart.! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/14/2011 13:03'!
initialize 

	super initialize.
	self compilingNotification: OrcaCompilingNotification new.! !

!OrcaControlPanel methodsFor: 'defaults' stamp: 'sw 4/12/2011 15:43'!
labelDebugSwazooMessages

	 ^ 'Show debug Swazoo Messages'! !

!OrcaControlPanel methodsFor: 'defaults' stamp: 'sw 4/12/2011 16:50'!
labelShowCompilingNotification

	 ^ 'Show Compiling Notification'! !

!OrcaControlPanel methodsFor: 'defaults' stamp: 'sw 4/14/2011 11:30'!
runButtonColor
	
	^ Color white! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 13:52'!
selection
	"just copied - don't know for what it is needed"

	^ 1 to: 0  "null selection"! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 14:15'!
setCurrentRootDir: input notifying: aController
	
	OrcaFileRequestHandler rootDirectory: input asString.
	self changed: #currentRootDirectory.
	^ true! !

!OrcaControlPanel methodsFor: 'build' stamp: 'sw 4/14/2011 11:34'!
setMorphColorsOf: aCollection
	"Because of a bug during building a checkbox, we need to set the color manually."
	
	aCollection do: [ :each |
		(each class == PluggableCheckBoxMorph) ifTrue: [ each color: self checkboxColor ].
		self setMorphColorsOf: each submorphs.
	].! !

!OrcaControlPanel methodsFor: 'morph actions' stamp: 'sw 4/14/2011 12:09'!
setPrecompileBlockTo: aBlock andPostCompileBlockTo: anotherBlock

	OrcaAbstractCodeFactory instance precompileBlock: aBlock.
	OrcaAbstractCodeFactory instance postcompileBlock: anotherBlock.! !

TestCase subclass: #OrcaControlPanelTest
	instanceVariableNames: 'panel originalStateOfDebugSwazooMessages originalStateOfShowCompilingNotification prettyCache origCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools-Tests'!

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:45'!
model
	
	^ self panel model! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:24'!
origCache
	^ origCache! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:24'!
origCache: anObject
	origCache := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:46'!
originalStateOfDebugSwazooMessages
	^ originalStateOfDebugSwazooMessages! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:46'!
originalStateOfDebugSwazooMessages: anObject
	originalStateOfDebugSwazooMessages := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:59'!
originalStateOfShowCompilingNotification
	^ originalStateOfShowCompilingNotification! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:59'!
originalStateOfShowCompilingNotification: anObject
	originalStateOfShowCompilingNotification := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 14:19'!
panel
	^ panel! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 14:19'!
panel: anObject
	panel := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:24'!
prettyCache
	^ prettyCache! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:24'!
prettyCache: anObject
	prettyCache := anObject! !

!OrcaControlPanelTest methodsFor: 'running' stamp: 'sw 4/12/2011 17:00'!
setUp 

	self panel: (OrcaControlPanel open).
	self originalStateOfDebugSwazooMessages: (Smalltalk at: #OrcaDebugSwazooInternalErrors ifAbsent: [ false ]).
	Smalltalk removeKey: #OrcaDebugSwazooInternalErrors ifAbsent: [].
	self originalStateOfShowCompilingNotification: (Smalltalk at: #OrcaShowCompilingNotification ifAbsent: [ false ]).
	Smalltalk removeKey: #OrcaShowCompilingNotification ifAbsent: [].
	
	self origCache: OrcaCodeFactory codeCache.
	self prettyCache: OrcaPrettyCodeFactory codeCache.! !

!OrcaControlPanelTest methodsFor: 'running' stamp: 'sw 4/12/2011 17:01'!
tearDown 

	self panel delete.
	Smalltalk at: #OrcaDebugSwazooInternalErrors put: self originalStateOfDebugSwazooMessages.
	Smalltalk at: #OrcaShowCompilingNotification put: self originalStateOfShowCompilingNotification.
		
	OrcaCodeFactory codeCache: self origCache.
	OrcaPrettyCodeFactory codeCache: self prettyCache.
	
	! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'sw 4/12/2011 14:29'!
testBuildSystemWindow

	self assert: ( self panel class == PluggableSystemWindow)! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'sw 4/12/2011 16:22'!
testClearCache

	self model clearCache.
	self assert: ( OrcaPrettyCodeFactory codeCache isEmpty).
	self assert: ( OrcaCodeFactory codeCache  isEmpty).
	
	! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'sw 4/12/2011 15:56'!
testToggleDebugSwazooMessages

	| oldState newState |
	oldState := self model debugSwazooMessages.
	self model changeDebugSwazooMessages.
	newState := self model debugSwazooMessages.
	self assert: ( oldState == (newState not)).
	
	
	! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'sw 4/14/2011 12:52'!
testToggleShowCompilingNotification

	| oldState newState |
	oldState := self model compilingNotificationIsVisible.
	self model changeShowCompilingNotification.
	newState := self model compilingNotificationIsVisible.
	
	self assert: ( oldState == (newState not)).
	
	
	! !

Morph subclass: #OrcaCompilingNotification
	instanceVariableNames: 'showCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools'!

OrcaCompilingNotification class
	instanceVariableNames: 'singleton'!

OrcaCompilingNotification class
	instanceVariableNames: 'singleton'!

!OrcaCompilingNotification methodsFor: 'configuration' stamp: 'sw 4/14/2011 13:06'!
hide

	(self showCounter == 1) 
		ifTrue: [ self showCounter: 0. 
				super hide ]
		ifFalse: [
			self showCounter: (self showCounter -1)
			].
! !

!OrcaCompilingNotification methodsFor: 'configuration' stamp: 'sw 4/14/2011 13:08'!
initialize 
	
	super initialize.
	self setProperties.
	self showCounter: 0.	
	super hide.! !

!OrcaCompilingNotification methodsFor: 'configuration' stamp: 'sw 4/12/2011 18:29'!
setProperties
	| t |
	
	t := TextMorph new
		contents:'Orca is compiling';
  		position: 75@150;
  		color: Color white.

		self color: Color blue;
			position: 50@50;
			extent: 160@120;
			addMorph: t;
			openInWorld.! !

!OrcaCompilingNotification methodsFor: 'configuration' stamp: 'sw 4/14/2011 13:07'!
show

	self showCounter: ( self showCounter + 1).
	super show. ! !

!OrcaCompilingNotification methodsFor: 'accessing' stamp: 'sw 4/14/2011 13:03'!
showCounter
	^ showCounter! !

!OrcaCompilingNotification methodsFor: 'accessing' stamp: 'sw 4/14/2011 13:03'!
showCounter: anObject
	showCounter := anObject! !
